﻿//=================================================================
//
//                    Rarekiller - Plugin
//                      Autor: katzerle
//          Honorbuddy Plugin - www.thebuddyforum.com
//
//==================================================================
using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Diagnostics;
using System.IO;
using System.Media;
using System.Windows.Media;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Pathing;
using System.Numerics;

namespace katzerle
{
    class RarekillerCollector
    {
        public static LocalPlayer Me = StyxWoW.Me;
        private static Stopwatch BlacklistTimer = new Stopwatch();

        //Landing Points for of Underground Objects
        public static Vector3 LandingPoint213364 = new Vector3(2288.31f, -1772.671f, 238.9393f);
        public static Vector3 LandingPoint214337 = new Vector3(2417.861f, -2929.056f, 8.610151f);
        public static Vector3 LandingPoint213649 = new Vector3(178.477f, 949.426f, 171.0682f);
        public static Vector3 LandingPoint213650 = new Vector3(291.5115f, 1772.154f, 310.9289f);
        public static Vector3 LandingPoint214340 = new Vector3(49.96476f, -950.9753f, 24.16642f);
        public static Vector3 LandingPoint213651 = new Vector3(-2998.009f, 952.5232f, 16.09599f);
        public static Vector3 LandingPoint213750 = new Vector3(-421.5852f, -366.7636f, 108.9386f);
        public static Vector3 LandingPoint214325 = new Vector3(805.1631f, -193.6357f, 407.6493f);
        public static Vector3 LandingPoint213768 = new Vector3(2677.461f, 1532.559f, 644.4728f);
        public static Vector3 LandingPoint213751 = new Vector3(2559.742f, 275.2169f, 496.4695f);
        public static Vector3 LandingPoint213770 = new Vector3(3386.12f, 1135.976f, 665.71f);
        public static Vector3 LandingPoint213793 = new Vector3(3501.53f, 1570.532f, 872.9788f);
        public static Vector3 LandingPoint213769 = new Vector3(3029.445f, 1674.854f, 649.7944f);
        public static Vector3 LandingPoint214438 = new Vector3(3525.092f, 841.6902f, 493.3049f);
        public static Vector3 LandingPoint214407 = new Vector3(2581.199f, 1817.027f, 670.2189f);
        public static Vector3 LandingPoint213956 = new Vector3(2188.075f, 5209.729f, 93.06538f);
        public static Vector3 LandingPoint213970 = new Vector3(-536.6893f, 4760.024f, 1.222435f);
        public static Vector3 LandingPoint213362 = new Vector3(-986.6257f, -2095.295f, 4.935998f);

        /// <summary>
        /// returns the WoWObject to interact with
        /// </summary>
        public WoWGameObject InteractableObject
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWGameObject>()
                .Where(o => (
                    !Blacklist.Contains(o.Guid, Rarekiller.Settings.Flags) 
                    && (Rarekiller.CollectObjectsList.ContainsKey(Convert.ToInt32(o.Entry)) && Rarekiller.Settings.ObjectsCollector)
                    ))
                .OrderBy(o => o.Distance).FirstOrDefault();
            }
        }

        /// <summary>
        /// Function Find and Pickup Objects
        /// </summary>
        public void findAndPickupObject(WoWGameObject InteractObject)
        {
            Logging.WriteQuiet(Colors.MediumPurple, "Rarekiller: Find A Object to collect {0} ID {1}", InteractObject.Name, InteractObject.Entry);
            Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Object Location: {0} / {1} / {2}", Convert.ToString(InteractObject.X), Convert.ToString(InteractObject.Y), Convert.ToString(InteractObject.Z));
            if (Rarekiller.Settings.LUAoutput)
                Lua.DoString("print('NPCScan: Find {0} ID {1}')", InteractObject.Name, InteractObject.Entry);

            if (Rarekiller.Settings.Alert)
                Rarekiller.Alert();

            // don't collect, if ...
            if (InteractObject.Entry == 213970  || InteractObject.Entry == 213362)
            {
                Logging.Write(Colors.MediumPurple, "Rarekiller: Can't reach Object because it is under Water {0}, Blacklist and Move on", InteractObject.Name);
                if (Rarekiller.Settings.LUAoutput)
                    Lua.DoString("print('NPCScan: Object is under Water')");
                Blacklist.Add(InteractObject.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                return;
            }

            // if not ID of known Underground Object of Another Mans Treasure --> don't collect
            if (!(InteractObject.Entry == 213364 || InteractObject.Entry == 214337 || InteractObject.Entry == 213649 || InteractObject.Entry == 213650 || InteractObject.Entry == 214340 || InteractObject.Entry == 213651
                || InteractObject.Entry == 213750 || InteractObject.Entry == 214325 || InteractObject.Entry == 213768 || InteractObject.Entry == 213751 || InteractObject.Entry == 213770 || InteractObject.Entry == 213793
                || InteractObject.Entry == 213769 || InteractObject.Entry == 214438 || InteractObject.Entry == 214407 || InteractObject.Entry == 213956)) // || o.Entry == 213970  || o.Entry == 213362
            {
                if (InteractObject.IsIndoors && Me.IsFlying && Me.IsOutdoors && (InteractObject.Location.Distance(Me.Location) > 30))
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Can't reach Object because it is Indoors and I fly Outdoors {0}, Blacklist and Move on", InteractObject.Name);
                    if (Rarekiller.Settings.LUAoutput)
                        Lua.DoString("print('NPCScan: Object is Indoors')");
                    Blacklist.Add(InteractObject.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    return;
                }
            }

            if (Rarekiller.DontInteract) return;

            // fly to Helperpoint if known Underground Object
            if (Me.IsFlying && (InteractObject.Entry == 213364 || InteractObject.Entry == 214337 || InteractObject.Entry == 213649 || InteractObject.Entry == 213650 || InteractObject.Entry == 214340 || InteractObject.Entry == 213651
                || InteractObject.Entry == 213750 || InteractObject.Entry == 214325 || InteractObject.Entry == 213768 || InteractObject.Entry == 213751 || InteractObject.Entry == 213770 || InteractObject.Entry == 213793
                || InteractObject.Entry == 213769 || InteractObject.Entry == 214438 || InteractObject.Entry == 214407 || InteractObject.Entry == 213956 || InteractObject.Entry == 213970 || InteractObject.Entry == 213362))
            {
                Vector3 Helperpoint = InteractObject.Location;
                if (InteractObject.Entry == 213364)
                    Helperpoint = LandingPoint213364;
                if (InteractObject.Entry == 214337)
                    Helperpoint = LandingPoint214337;
                if (InteractObject.Entry == 213649)
                    Helperpoint = LandingPoint213649;
                if (InteractObject.Entry == 213650)
                    Helperpoint = LandingPoint213650;
                if (InteractObject.Entry == 214340)
                    Helperpoint = LandingPoint214340;
                if (InteractObject.Entry == 213651)
                    Helperpoint = LandingPoint213651;
                if (InteractObject.Entry == 213750)
                    Helperpoint = LandingPoint213750;
                if (InteractObject.Entry == 214325)
                    Helperpoint = LandingPoint214325;
                if (InteractObject.Entry == 213768)
                    Helperpoint = LandingPoint213768;
                if (InteractObject.Entry == 213751)
                    Helperpoint = LandingPoint213751;
                if (InteractObject.Entry == 213770)
                    Helperpoint = LandingPoint213770;
                if (InteractObject.Entry == 213793)
                    Helperpoint = LandingPoint213793;
                if (InteractObject.Entry == 213769)
                    Helperpoint = LandingPoint213769;
                if (InteractObject.Entry == 214438)
                    Helperpoint = LandingPoint214438;
                if (InteractObject.Entry == 214407)
                    Helperpoint = LandingPoint214407;
                if (InteractObject.Entry == 213956)
                    Helperpoint = LandingPoint213956;
                if (InteractObject.Entry == 213970)
                    Helperpoint = LandingPoint213970;
                if (InteractObject.Entry == 213362)
                    Helperpoint = LandingPoint213362;

                if (!Rarekiller.MoveTo(Helperpoint, 5, false)) return;
                Rarekiller.Dismount();
            }

            // Move to Object
            if (InteractObject.Entry == 213364 || InteractObject.Entry == 214337 || InteractObject.Entry == 213649 || InteractObject.Entry == 213650 || InteractObject.Entry == 214340 || InteractObject.Entry == 213651
                || InteractObject.Entry == 213750 || InteractObject.Entry == 214325 || InteractObject.Entry == 213768 || InteractObject.Entry == 213751 || InteractObject.Entry == 213770 || InteractObject.Entry == 213793
                || InteractObject.Entry == 213769 || InteractObject.Entry == 214438 || InteractObject.Entry == 214407 || InteractObject.Entry == 213956 || InteractObject.Entry == 213970 || InteractObject.Entry == 213362)
            { if (!Rarekiller.MoveTo(InteractObject, 4, true)) return; }
            else
            { if (!Rarekiller.MoveTo(InteractObject, 4, false)) return; }

            // Collect Object
            Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Object Location: {0} / {1} / {2}", Convert.ToString(InteractObject.X), Convert.ToString(InteractObject.Y), Convert.ToString(InteractObject.Z));
            Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: My Location: {0} / {1} / {2}", Convert.ToString(Me.X), Convert.ToString(Me.Y), Convert.ToString(Me.Z));
            Rarekiller.Dismount();
            if (Rarekiller.ToonInvalidCombat) return;
            Thread.Sleep(1000);
            InteractObject.Interact();
            InteractObject.Interact();
            InteractObject.Interact();
            Thread.Sleep(5000);
            Lua.DoString("RunMacroText(\"/click StaticPopup1Button1\");");
            Thread.Sleep(1000);
            Logging.Write(Colors.MediumPurple, "Rarekiller: Interact with {0} - ID {1}", InteractObject.Name, InteractObject.Entry);
        }
    }
}
