﻿//=================================================================
//
//                    Rarekiller - Plugin
//                      Autor: katzerle
//          Honorbuddy Plugin - www.thebuddyforum.com
//
//==================================================================
using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Diagnostics;
using System.IO;
using System.Media;
using System.Windows.Media;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Pathing;


namespace katzerle
{
    class RarekillerTamer
    {
        public static LocalPlayer Me = StyxWoW.Me;
        private static Stopwatch BlacklistTimer = new Stopwatch();
        private static Stopwatch Alerttimer = new Stopwatch();

        /// <summary>
        /// returns the WoWUnit to tame as Pet
        /// </summary>
        public WoWUnit tameablePet
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>()
                .Where(o => (!Blacklist.Contains(o.Guid, Rarekiller.Settings.Flags) && ((
                (Rarekiller.Settings.TameList && Rarekiller.TameableMobsList.ContainsKey(Convert.ToInt32(o.Entry)))
                || (Rarekiller.Settings.TameByID && (o.Entry == Convert.ToInt64(Rarekiller.Settings.TameMobID)))
                ) && !o.IsPet && o.IsTameable)))
                .OrderBy(o => o.Distance).FirstOrDefault();
            }
        }

        /// <summary>
        /// Function to Find and Tame Mobs
        /// </summary>
        public void findAndTameMob(WoWUnit tamePet)
        {
            if (Me.Class != WoWClass.Hunter)
                return;     

            if (!tamePet.IsDead)
            {
                Logging.WriteQuiet(Colors.MediumPurple, "Rarekiller: Found a new Pet {0} ID {1}", tamePet.Name, tamePet.Entry);
                Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Unit Location: {0} / {1} / {2}", Convert.ToString(tamePet.X), Convert.ToString(tamePet.Y), Convert.ToString(tamePet.Z));
                if (Rarekiller.Settings.LUAoutput)
                    Lua.DoString("print('NPCScan: Find {0} ID {1}')", tamePet.Name, tamePet.Entry);

                // Don't tame the Rare if ...
                if (Me.IsFlying && Me.IsOutdoors && tamePet.IsIndoors)
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Unit is Indoors and I fly Outdoors, so blacklist him to prevent Problems");
                    Logging.Write(Colors.MediumPurple, "Rarekiller: You have to place me next to the Spawnpoint, if you want me to hunt this Unit.");
                    Blacklist.Add(tamePet.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    Logging.WriteDiagnostic(Colors.MediumPurple, " Part TamerRarekiller: Blacklist Unit for 5 Minutes.");
                    if (Rarekiller.Settings.LUAoutput)
                        Lua.DoString("print('NPCScan: NPC is Indoors')", tamePet.Name);
                    return;
                }
                if (Me.Level < tamePet.Level)
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Unit Level is higher then mine, can't tame the Unit.");
                    Blacklist.Add(tamePet.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                    if (Rarekiller.Settings.LUAoutput)
                        Lua.DoString("print('NPCScan: NPC Level is to high to tame')", tamePet.Name);
                    return;
                }
                if (Rarekiller.BlacklistMobsList.ContainsKey(Convert.ToInt32(tamePet.Entry)))
                {
                    Logging.Write(Colors.MediumPurple, "Rarekiller: {0} is Member of the BlacklistedMobs.xml", tamePet.Name);
                    Blacklist.Add(tamePet.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                    Logging.WriteDiagnostic(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                    return;
                }

                if (Rarekiller.DontInteract) return;             

                if (Rarekiller.Settings.Alert)
                    Rarekiller.Alert();

                // Move to tameable unit
                if(!Rarekiller.MoveTo(tamePet, 35, false)) return;
                if (Me.IsFlying)
                    if (!Rarekiller.DescendToLand(tamePet)) return;
                Rarekiller.Dismount();

                while (Me.IsFalling)
                {
                    Thread.Sleep(500);
                }

                //Dismiss Pet
                Thread.Sleep(1000);
                if (RarekillerSpells.CastSafe("Dismiss Pet", Me, true))
                {
                    Thread.Sleep(3000);
                }

                if (!Rarekiller.MoveTo(tamePet, 20, true)) return;

                tamePet.Target();
                if (Me.Class == WoWClass.Hunter)
                {
                    // Tame Pet
                    while (!tamePet.IsPet)
                    {
                        if (tamePet.IsDead)
                        {
                            Logging.Write(Colors.MediumPurple, "Rarekiller: Oh no, I accidently killed him !!! ");
                            return;
                        }
                        if (Me.HealthPercent < 10)
                        {
                            Logging.Write(Colors.MediumPurple, "Rarekiller: Health < 10% , Use Feign Death !!! ");
                            if (SpellManager.CanCast("Feign Death"))
                                RarekillerSpells.CastSafe("Feign Death", Me, false);
                            //SpellManager.Cast("Feign Death");
                            return;
                        }

                        if (!(Me.CastingSpellId == 1515))
                        {
                            WoWMovement.MoveStop();
                            RarekillerSpells.CastSafe("Tame Beast", tamePet, true);
                            //SpellManager.Cast(1515);
                            Logging.Write(Colors.MediumPurple, "Rarekiller: Try to tame Beast {0}", tamePet.Name);
                            Thread.Sleep(500);
                        }
                    }
                    Logging.Write(Colors.MediumPurple, "Rarekiller: Sucessfully tamed Beast {0}", tamePet.Name);
                }                  
            }
            else if (tamePet.IsPet)
                return;
            else if (Blacklist.Contains(tamePet.Guid, Rarekiller.Settings.Flags))
                return;
            else
            {
                Logging.Write(Colors.MediumPurple, "Rarekiller: Find a Unit, but sadly he's dead or not tameable: {0}", tamePet.Name);
                Blacklist.Add(tamePet.Guid, Rarekiller.Settings.Flags, TimeSpan.FromSeconds(Convert.ToInt64(Rarekiller.Settings.BlacklistEnd)));
                Logging.Write(Colors.MediumPurple, "Rarekiller: Blacklist Mob");
                return;
            }
        }
    }
}
